require 'json'
require 'net/http'
require_relative 'request_failed_error'

# DEPRECATED
module Seiso
  class Connector
    class ConnectorV1
      attr_reader :http
      attr_reader :username
      
      def initialize(http, username, password)
        @http = http
        @username = username
        @password = password
        @request_headers = {
          "Accept" => "application/json",
          "Content-Type" => "application/json",
          "X-User-Agent" => username
        }
      end

      def do_get(path)
        request = Net::HTTP::Get.new(path, initheader = @request_headers)
        request.basic_auth(@username, @password)
        response = @http.request(request)
        raise(Seiso::Connector::RequestFailedError, response.body) if !response.kind_of?(Net::HTTPSuccess)
        JSON.parse(response.body)
      end

      def do_post(path, data)
        puts "POST #{path}"
        request = Net::HTTP::Post.new(path, initheader = @request_headers)
        request.basic_auth(@username, @password)
        request.body = data.to_json
        response = @http.request(request)
        display_response(response)
      end

      def do_put(path, data)
        puts "PUT #{path}"
        request = Net::HTTP::Put.new(path, initheader = @request_headers)
        request.basic_auth(@username, @password)
        request.body = data.to_json
        response = @http.request(request)
        display_response(response)
      end

      private
      
      # Displays an HTTP response on the command line.
      # - response: response to display
      def display_response(response)
        case response.code
        when "500"
          puts "Server error: #{response.code} #{response.message}"
        else
          puts "#{response.code} #{response.message}"
          puts "#{response.body}"
        end
      end
    end
  end
end
